#C.Dupaty 12/2013
#Test SPI : RTC avec module MIKROELEKTRONIKA "serial 7-SEG Display 8-DIGIT"

#!/usr/bin/python
# Horloge  
import spidev #bibliotheque SPI
import time   # pour tempo 1s

# active le BUS SPI 
spi = spidev.SpiDev()   #nouvel objet SPI
spi.open(0,0)		# sur port SPI 0 CS 0
spi.max_speed_hz = 1000000  # vitesse en Hz

global heu,min,sec,jsemaine,jour,mois,annee # variables globales

# codes 7 segments
code7seg = (0x7E,0x30,0x6D,0x79,0x33,0x5B,0x5F,0x70,0x7F,0x7B) 
# tuple des jours de la semaine
nom_jour=('lundi','mardi','mercredi','jeudi','vendredi','samedi','dimanche')

# initialise le MAX7912
def Initialise():
  spi.writebytes([0x09])  #decoder BCD
  spi.writebytes([0x0])  #(0 pour ne pas decoder)

  spi.writebytes([0x0a])   # regle la luminance
  spi.writebytes([0x08])   # 17/32

  spi.writebytes([0x0b])   # affiche les 8 digits
  spi.writebytes([0x07])

  spi.writebytes([0x0c])  # power-down mode: 0. normal mode:1
  spi.writebytes([0x01])  # (0 pour shutdown)

  spi.writebytes([0x0f])  # test display: 1; EOT. display: 0
  spi.writebytes([0x00])  # (1 pour test)

# ecriture SPI
def ecr_nb(digit,val):
	spi.xfer2([digit,val])

# eteind tous les aff 7seg
def efface():
	d=8
	while(d):
    	    ecr_nb(d,0b00000000)
	    d-=1
	ecr_nb(3,0b00000001)
	ecr_nb(6,0b00000001)
	
# affiche heu, min sec sur les afficheurs
def aff_heure():
	global heu,min,sec
	ecr_nb(7,code7seg[heu%10])     #heures
	ecr_nb(8,code7seg[heu/10 %10]) #dizaines d heures
	ecr_nb(4,code7seg[min%10])     #minutes
	ecr_nb(5,code7seg[min/10 %10]) #dizaines de minutes
	ecr_nb(1,code7seg[sec%10])     #secondes
	ecr_nb(2,code7seg[sec/10 %10]) #dizaines de secondes

# lit l heure systeme et la range dans les variables heu, min, sec
def lit_heure():
	global heu,min,sec,jsemaine,jour,mois,annee
    	t=time.localtime()  # t est un tuple du temps local
	heu=t[3]
	min=t[4]
	sec=t[5]
	jsemaine=t[6]
	jour=t[2]
	mois=t[1]
	annee=t[0]

def RTC():
	global heu,min,sec,jsemaine,jour,mois,annee
        sec+=1         # calcul les nouvelle heure
        if sec >= 60:
          sec=0
          min+=1
          if min>=60:
            min=0
            heu+=1
            if heu >=24:
              heu=0
	      lit_heure() # on recharge l heure systeme toutes les 24h
        aff_heure()     # l affiche

def main():
	global heu,min,sec,jsemaine,jour,mois,annee
	Initialise()     
	efface()
        # paramatres du bus SPI
	print 'mode : ' ,spi.mode      # mode, phases SCK SDA
	print 'cshight : ' ,spi.cshigh # etat de CS
	print 'lsbfirst : ' ,spi.lsbfirst  # poids faibles emis en premier ?
	print 'threewire : ' ,spi.threewire # SDI est connectee
	print 'loop : ' ,spi.loop            # ?
	print 'bits_per_word : ' ,spi.bits_per_word # nombre de bits par mot
	print 'max_speed_hz : ' ,spi.max_speed_hz   # vitesse en Hz
	print 'C EST PARTI CTRL-C pour arreter'
	lit_heure()        # lit l heure systeme
	while True:   
	   RTC()           # calcule la nouvelle heure
           print '%s %2d/%2d/%4d - %2d:%2d:%2d'%(nom_jour[jsemaine],jour,mois,annee,heu,min,sec)
	   time.sleep(1)  # libere le processeur pour 1s

if __name__ == '__main__':
   main()
